//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Yellow
#property indicator_color2 Olive
#property indicator_color3 Olive
#property indicator_color4 Orange
#property indicator_color5 Orange
#property indicator_color6 Gray
#property indicator_color7 Gray


extern int    LR.length     = 55;
extern double std.channel.1 =  1;
extern double std.channel.2 =  2;
extern double std.channel.3 =  3;
extern int    Price         = PRICE_CLOSE;

//
//
//
//
//

double mean.Buffer[];
double high.1.Buffer[];
double low.1.Buffer[];
double high.2.Buffer[];
double low.2.Buffer[];
double high.3.Buffer[];
double low.3.Buffer[];
double prices[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,mean.Buffer);
   SetIndexBuffer(1,high.1.Buffer);
   SetIndexBuffer(2,low.1.Buffer);
   SetIndexBuffer(3,high.2.Buffer);
   SetIndexBuffer(4,low.2.Buffer);
   SetIndexBuffer(5,high.3.Buffer);
   SetIndexBuffer(6,low.3.Buffer);
   SetIndexBuffer(7,prices);
   SetIndexLabel(0,"mean");
   SetIndexLabel(1,"1st Std up");
   SetIndexLabel(2,"1st Std down");
   SetIndexLabel(3,"2nd Std up");
   SetIndexLabel(4,"2nd Std down");
   SetIndexLabel(5,"3rd Std up");
   SetIndexLabel(6,"3rd Std down");
return(0);
}
int deinit() {}

//
//
//
//
//

int start()
{
   int limit,i,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      prices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         
         double slope;
         double value   = iLRValue(slope,LR.length,i);
         double std.dev = 0;

            for(int k=0; k<LR.length; k++)
            {
               double diff = prices[i+k]-(value-k*slope);
                  std.dev += diff*diff;
            }
            std.dev = MathSqrt(std.dev/(LR.length-1.0));
      
      //
      //
      //
      //
      //
      
      mean.Buffer[i]   = value;
      high.1.Buffer[i] = mean.Buffer[i]+(std.channel.1*std.dev);
      low.1.Buffer[i]  = mean.Buffer[i]-(std.channel.1*std.dev);
      high.2.Buffer[i] = mean.Buffer[i]+(std.channel.2*std.dev);
      low.2.Buffer[i]  = mean.Buffer[i]-(std.channel.2*std.dev);
      high.3.Buffer[i] = mean.Buffer[i]+(std.channel.3*std.dev);
      low.3.Buffer[i]  = mean.Buffer[i]-(std.channel.3*std.dev);
   }
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
//
//
//
//
//

int    lr.period=0;
double lr.sumX;
double lr.sumXSqr;
double lr.divisor;

//
//
//
//
//

double iLRValue(double& LinearRegSlope, int len, int shift)
{
   double LinearRegValue;
   double Intercept;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lr.period != len)
   {
      lr.period  = len;
      lr.sumX    = lr.period * (lr.period-1) / 2.0;
      lr.sumXSqr = lr.period * (lr.period-1) * (2.0 * lr.period - 1.0) / 6.0;
      lr.divisor = MathPow(lr.sumX,2.0) - lr.period * lr.sumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lr.period; i++)
   {
      double price = prices[i+shift];
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lr.divisor != 0 ) 
         	LinearRegSlope = (lr.period * SumXY - lr.sumX * SumY)/lr.divisor;
   else     LinearRegSlope = 0; 
   
   //
   //
   //
   //
   //
   
   Intercept      = (SumY - LinearRegSlope * lr.sumX) / lr.period ;
	LinearRegValue = Intercept  + LinearRegSlope * (lr.period-1);
   return(LinearRegValue);
}